/*==============================================================*/
/* DBMS name:      MySQL 5.0                                    */
/* Created on:     2018/1/23 16:01:23                           */
/*==============================================================*/


drop table if exists tbl_diting_target;

/*==============================================================*/
/* Table: tbl_diting_target                                     */
/*==============================================================*/
create table tbl_diting_target
(
   id                   bigint not null auto_increment,
   name                 varchar(256) not null comment 'target name',
   type                 varchar(64) not null comment 'target type. e.g. (java application, database...)',
   group                varchar(64) not null comment 'target group, e.g. (xx business, xx project...)',
   protocol             varchar(64) not null comment 'monitor connect protocol(jmx/rmi/http/...)',
   url                  varchar(1024) not null comment 'connect url, e.g. (service:jmx:jmxmp://127.0.0.1:1090)',
   cron_express         varchar(32) not null comment 'cron express',
   create_time          datetime not null default CURRENT_TIMESTAMP comment 'create time',
   modify_time          datetime comment 'modified time',
   primary key (id)
);

alter table tbl_diting_target comment '监控目标';

