(function($) {

	$.fn.daterpinit = function(options) {
		var defaults = {
			startDate : '',
			endDate : '',
			pattern : 'YYYY-MM-DD',
			changeHandler : function(start, end) {
			}
		};

		var settings = $.extend({}, defaults, options);

		return initDaterangepicker(this, settings);
	}

	function initDaterangepicker(daterange, settings) {
		var changeHandler = settings.changeHandler;
		var pattern = settings.pattern;
		var startDate = (settings.startDate) 
				? moment(settings.startDate, pattern) : moment().subtract('days', 6);
		var endDate = (settings.endDate) 
				? moment(settings.endDate,   pattern) : moment();

		var picker = daterange.daterangepicker({
			locale : {
				fromLabel : '开始时间',
				toLabel : '结束时间',
				applyLabel : '确定',
				cancelLabel : '取消',
				customRangeLabel : '自定义时间',
				daysOfWeek : [ '日', '一', '二', '三', '四', '五', '六' ],
				monthNames : [ '1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月' ],
				firstDay : 1
			},
			ranges: {
				'最后7天': [moment().subtract('days', 6), moment()],
				'最后30天': [moment().subtract('days', 29), moment()],
				'本月': [moment().startOf('month'), moment().endOf('month')],
				'上月': [moment().subtract('month', 1).startOf('month'), moment().subtract('month', 1).endOf('month')],
				'最近1年': [moment().startOf('year'), moment().endOf('year')]
		    },
			startDate : startDate,
			endDate : endDate
		}, function(start, end, label) {
			daterange.find('.date-start').html(start.format(pattern));
			daterange.find('.date-end').html(end.format(pattern));
			changeHandler(start.format(pattern), end.format(pattern));
	    });
		daterange.find('.date-start').html(startDate.format(pattern));
		daterange.find('.date-end').html(endDate.format(pattern));
		changeHandler(startDate.format(pattern), endDate.format(pattern));

		return picker;
	}
})(jQuery);