$(document).ajaxStart(function() {
	NProgress.start();
}).ajaxComplete(function(event, request, settings) {
	NProgress.done();
}).ajaxError(function(event, xhr, options, exc) {
    Toast.danger(exc);
});

var Tag = {
	medially: function(o) {
		var height = $(o).outerHeight();
		var wh = $(window).height();
		$(o).css('margin-top', (wh - height)/2);
	}
};

var StringUtils = {
	isBlank: function(string) {
		return !string || string.length <= 0;
	},
	isNotBlank: function(string) {
		return !this.isBlank(string);
	}
};

// Extend the default Number object with a formatMoney() method:
// usage: someVar.formatMoney(decimalPlaces, symbol, thousandsSeparator, decimalSeparator)
// defaults: (2, "$", ",", ".")
Number.prototype.formatMoney = function (places, symbol, thousand, decimal) {
    places = !isNaN(places = Math.abs(places)) ? places : 2;
    symbol = symbol !== undefined ? symbol : "$";
    thousand = thousand || ",";
    decimal = decimal || ".";
    var number = this,
        negative = number < 0 ? "-" : "",
        i = parseInt(number = Math.abs(+number || 0).toFixed(places), 10) + "",
        j = (j = i.length) > 3 ? j % 3 : 0;
    return symbol + negative + (j ? i.substr(0, j) + thousand : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand) + (places ? decimal + Math.abs(number - i).toFixed(places).slice(2) : "");
};

var Btn = {
	loading: function(e) {
		$(e.target).data('reset', $(e.target).text()).text($(e.target).data('loading')).prop('disabled', true);
	},
	reset: function(e) {
		$(e.target).text($(e.target).data('reset')).prop('disabled', false);
	},
	text: function(e, regx) {
		$(e.target).text($(e.target).data(regx));
	}
};

// --------- toast ---------- //
var Toast = {
	info: function(t, delay) {
		Toast.open(t, 'info', delay);
	},
	success: function(t, delay) {
		Toast.open(t, 'success', delay);
	},
	danger: function(t, delay) {
		Toast.open(t, 'danger', delay);
	},
	open: function(t, type, delay) {
		$.bootstrapGrowl(t, {
		  type: type,
	      align: 'center',
	      width: 'auto',
	      delay: delay || 3000,
	      offset: {
	        from: "top",
	        amount: ($(window).height()-50)/2
	      },
	      allow_dismiss: false
		});
	}
};

// ---------- logger ---------- //
var Log = {
    debug : function(txt) {
        if (window.console&&window.console.log) {
            console.log(txt);
        }
    }
};

// ---------- nvwa -------------- //
var Nvwa = {
    colFormatter: {},
    ReExp: {
        time: /^\d{4}-\d{1,2}-\d{1,2} \d{1,2}:\d{1,2}:\d{1,2}$/,         // yyyy-MM-dd HH:mm:ss
        number: /^\d+$/              // 正整数
    },
    Ajax: {},
};

Nvwa.Ajax.simple = function(json, fn, always) {
    if (json && json.success) {
        fn(json);
    }
    else {
        Toast.danger(json.msg);
    }
    if (always) always(json);
}

template.defaults.escape = false;

template.helper('dateFormat', function (date, format) {
    if (!date) {
        return "";
    }
    return DateUtil.format(date, format);
});

template.helper('format', function (v, colFormatter, params) {
    var formatterFn = Nvwa.colFormatter[colFormatter];
    return formatterFn ? formatterFn(v, params) : obj;
});

/**
 * 封装的分页表格
 */
function NvwaTable(options) {
    this.cachedParams = {};

    //var defaultOpts = {
    //    url: '',
    //    templateId: '',
    //    pageSize: 10,
    //    container: null
    //};

    this.container = options.container;
    this.pageNo = options.pageNo || 1;
    this.pageSize = options.pageSize || 20;
    this.templateId = options.templateId;
    this.url = options.url;
    this.callback = options.callback;

    var _this = this;

    _this.renderEmpty = function () {
        _this.render({}, 0, {}, 1);
    };

    _this.render = function (rows, results, params, curPage) {
        var html = template(_this.templateId, {rows: rows, results: results, pageSize: _this.pageSize});
        _this.container.html(html);
        //_this.container.children('table').footable();

        if (results == 0) results = 1;
        _this.container.find(".pagination-sm").twbsPagination({
            totalPages: (results % _this.pageSize == 0) ? results / _this.pageSize : results / _this.pageSize + 1,
            visiblePages: 7,
            startPage: curPage,
            first: '«',
            prev: '‹',
            next: '›',
            last: '»',
            onPageClick: function (event, page) {
                _this.post(_this.cachedParams, page);
            }
        });
    };

    _this.post = function (params, curPage) {
        if (typeof(curPage) == 'number') {
            _this.pageNo = curPage;
        }

        params['pageNo'] = _this.pageNo;
        params['pageSize'] = _this.pageSize;
        $.ajax({
            url: _this.url,
            type: 'POST',
            dataType: 'json',
            data: params,
            success: function (json) {
                if (json && json.success) {
                    _this.cachedParams = params;
                    var results = json['results'];
                    var rows = json['rows'];
                    _this.render(rows, results, params, _this.pageNo);
                } else {
                    if (json) {
                        Toast.danger(json['msg']);
                    }
                }
                if (_this.callback) {
                    _this.callback();
                }
            }
        });
    };
}

jQuery.fn.extend({
    nvwaTable: function (options) {
        var container = $(this);
        var opts = {};
        $.extend(opts, options, {container: container});
        return new NvwaTable(opts);
    }
});

// ------ NvwaTable end ------ //
